#pragma once
#include "dinkyecs.hpp"
#include "map.hpp"
#include "combat.hpp"
#include "inventory.hpp"
#include <deque>
#include "tser.hpp"

namespace components {
  struct Player {
    DinkyECS::Entity entity;
    DEFINE_SERIALIZABLE(Player, entity);
  };

  struct Position {
    Point location;
    DEFINE_SERIALIZABLE(Position, location);
  };

  struct Motion {
    int dx;
    int dy;
    DEFINE_SERIALIZABLE(Motion, dx, dy);
  };

  struct Loot {
    int amount;
    DEFINE_SERIALIZABLE(Loot, amount);
  };

  struct Tile {
    std::string chr;
    DEFINE_SERIALIZABLE(Tile, chr);
  };

  struct GameConfig {
    Config game;
    Config enemies;
    Config items;
    Config tiles;
  };

  struct EnemyConfig {
    int HEARING_DISTANCE;
  };

  struct Debug {
    bool PATHS=false;
    bool LIGHT=false;
  };

  struct Weapon {
    int damage = 0;
  };
}
